---
title: TextTrackList
slug: Web/API/TextTrackList
tags:
  - API
  - HTML DOM
  - HTMLMediaElement
  - Interface
  - Media
  - Reference
  - TextTrackList
  - Track List
  - Tracks
  - list
---
<div>{{APIRef("HTML DOM")}}</div>

<p><span class="seoSummary">The <strong><code>TextTrackList</code></strong> interface is used to represent a list of the text tracks defined by the {{HTMLElement("track")}} element, with each track represented by a separate {{domxref("textTrack")}} object in the list.</span></p>

<p>Retrieve an instance of this object with {{domxref('HTMLMediaElement.textTracks')}}. The individual tracks can be accessed using array syntax or functions such as {{jsxref("Array.forEach", "forEach()")}} for example.</p>

<h2 id="Properties">Properties</h2>

<p><em>This interface also inherits properties from its parent interface, {{domxref("EventTarget")}}.</em></p>

<dl>
 <dt>{{domxref("TextTrackList.length", "length")}} {{ReadOnlyInline}}</dt>
 <dd>The number of tracks in the list.</dd>
</dl>

<h2 id="Event_handlers">Event handlers</h2>

<dl>
 <dt>{{domxref("TextTrackList.onaddtrack", "onaddtrack")}}</dt>
 <dd>An event handler to be called when the {{event("addtrack")}} event is fired, indicating that a new text track has been added to the media element.</dd>
 <dt>{{domxref("TextTrackList.onchange", "onchange")}}</dt>
 <dd>An event handler to be called when the {{event("change")}} event occurs.</dd>
 <dt>{{domxref("TextTrackList.onremovetrack", "onremovetrack")}}</dt>
 <dd>An event handler to call when the {{event("removetrack")}} event is sent, indicating that a text track has been removed from the media element.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>This interface also inherits methods from its parent interface, {{domxref("EventTarget")}}.</em></p>

<dl>
 <dt>{{domxref("TextTrackList.getTrackById", "getTrackById()")}}</dt>
 <dd>Returns the {{domxref("TextTrack")}} found within the <code>TextTrackList</code> whose {{domxref("TextTrack.id", "id")}} matches the specified string. If no match is found, <code>null</code> is returned.</dd>
</dl>

<h2 id="Events">Events</h2>

<dl>
 <dt><code><a href="/en-US/docs/Web/API/TextTrackList/addtrack_event">addtrack</a></code></dt>
 <dd>Fired when a new text track has been added to the media element.<br>
 Also available via the <code><a href="/en-US/docs/Web/API/TextTrackList/onaddtrack">onaddtrack</a></code> property.</dd>
 <dt><code><a href="/en-US/docs/Web/API/TextTrackList/change_event">change</a></code></dt>
 <dd>Fired when a text track has been made active or inactive.<br>
 Also available via the <code><a href="/en-US/docs/Web/API/TextTrackList/onchange">onchange</a></code> property.</dd>
 <dt><code><a href="/en-US/docs/Web/API/TextTrackList/removeTrack">removetrack</a></code></dt>
 <dd>Fired when a new text track has been removed from the media element.<br>
 Also available via the <code><a href="/en-US/docs/Web/API/TextTrackList/onremovetrack">onremovetrack</a></code> property.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>In addition to being able to obtain direct access to the text tracks present on a media element, <code>TextTrackList</code> lets you set event handlers on the {{event("addtrack")}} and {{event("removetrack")}} events, so that you can detect when tracks are added to or removed from the media element's stream. See {{domxref("TextTrackList.onaddtrack", "onaddtrack")}} and {{domxref("TextTrackList.onremovetrack", "onremovetrack")}} for details and examples.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Getting_a_video_element's_text_track_list">Getting a video element's text track list</h3>

<p>To get a media element's {{domxref("TextTrackList")}}, use its {{domxref("HTMLMediaElement.textTracks", "textTracks")}} property.</p>

<pre class="brush: js">var textTracks = document.querySelector("video").textTracks;</pre>

<h3 id="Monitoring_track_count_changes">Monitoring track count changes</h3>

<p>In this example, we have an app that displays information about the number of channels available. To keep it up to date, handlers for the {{event("addtrack")}} and {{event("removetrack")}} events are set up.</p>

<pre class="brush: js">textTracks.onaddtrack = updateTrackCount;
textTracks.onremovetrack = updateTrackCount;

function updateTrackCount(event) {
  trackCount = textTracks.length;
  drawTrackCountIndicator(trackCount);
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', '#texttracklist', 'TexTrackList')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.TextTrackList")}}</p>
